Hooks:PostHook(GamePlayCentralManager, "init", "flashlight_init", function(self)
	self._level_flashlight_state = self._flashlights_on -- keep track of what the level has requested for flashlights for syncing to drop-ins

	self:set_flashlights_on()
end)

local set_flashlights_on_orig = GamePlayCentralManager.set_flashlights_on
function GamePlayCentralManager:set_flashlights_on(flashlights_on, ...)
	local flashlight_state = NPCFlashlights.settings[Global.level_data.level_id]
	if flashlights_on ~= nil then -- vanilla calls with a state
		self._level_flashlight_state = flashlights_on
	elseif flashlight_state == 2 then
		return set_flashlights_on_orig(self, self._level_flashlight_state, ...) 
	end

	flashlights_on = flashlight_state == 3 or flashlight_state == 2 and flashlights_on or false

	return set_flashlights_on_orig(self, flashlights_on, ...)
end

Hooks:PostHook(GamePlayCentralManager, "save", "flashlight_save", function(self, data)
	data.GamePlayCentralManager.flashlights_on = self._level_flashlight_state -- what the level has requested instead of what more npc flashlights has set
end)